/* 
 * Copyright (c) Service Management Integrations Limited, 2014 - 2018
 * All Rights Reserved.
 * NOTICE: All information contained herein is and remains the property of Service Management  Integrations Limited.  The intellectual and technical concepts contained herein are proprietary to Service Management Integrations Limited and are protected by copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Service Management Integrations Limited.
 */
(function transformRow(source, target, map, log, isUpdate) {
    ignore=true;
	
    try {
            var request = new sn_ws.RESTMessageV2();
            var instanceURL = gs.getProperty('glide.servlet.uri');
            var isRecordUpdate;
            if(source.target_sys_id.equals("-1")) {
                    //create (POST)
                    request.setHttpMethod('POST');
                    request.setEndpoint(instanceURL+'api/now/table/sn_hr_core_service');
                    isRecordUpdate=false;
            }
            else { //UPADTE (PUT)
                    request.setHttpMethod('PUT');
                    request.setEndpoint(instanceURL+"api/now/table/sn_hr_core_service/"+source.target_sys_id+"?sysparm_exclude_ref_link=true");
                    isUpdate=true;
            }

            //authentication
            var user = gs.getProperty("x_semai_hrm.p_rest_user");
            var password =gs.getProperty("x_semai_hrm.p_rest_password");

            request.setBasicAuth(user,password);
            request.setRequestHeader("Accept","application/json");
            request.setRequestHeader('Content-Type','application/json');
            //build the request body

            var body="{";
            if(!source.active.nil())body+="\"active\":\""+source.active+"\",";
            if(!source.approval_options.nil())body+="\"approval_options\":\""+source.approval_options+"\",";
            if(!source.case_options.nil())body+="\"case_options\":\""+source.case_options+"\",";
            if(!source.description.nil())body+="\"description\":\""+source.description.replace(/\"/g,"\\\"")+"\",";+"\",";
            if(!source.fulfillment_instructions.nil())body+="\"fulfillment_instructions\":\""+source.fulfillment_instructions+"\",";
            if(!source.kb_articles.nil())body+="\"kb_articles\":\""+source.kb_articles+"\",";
            if(!source.name.nil())body+="\"name\":\""+source.name+"\",";
            if(!source.service_table.nil())body+="\"service_table\":\""+source.service_table+"\",";
            if(!source.service_table_fields.nil())body+="\"service_table_fields\":\""+source.service_table_fields+"\",";
            if(!source.subject_person_related_lists.nil())body+="\"subject_person_related_lists\":\""+source.subject_person_related_lists+"\",";
            if(!source.sys_replace_on_upgrade.nil())body+="\"sys_replace_on_upgrade\":\""+source.sys_replace_on_upgrade+"\",";
            if(!source.target_scope.nil())body+="\"sys_scope\":\""+source.target_scope+"\",";
            if(!source.template.nil())body+="\"template\":\""+source.template+"\",";
            if(!source.topic_detail.nil())body+="\"topic_detail\":\""+source.topic_detail+"\",";
            if(!source.value.nil())body+="\"value\":\""+source.value+"\",";

            body=body.slice(0,-1); //remove the final  comma 
            body+="}";
            body=body.replace(/[\n\r\t]/g,'');
            request.setRequestBody(body);

            var response = request.execute();
            if(response.haveError()) {
                    error=true;
                    error_message="["+ response.getErrorCode()+"] "+response.getErrorMessage();
            }
            else {
                    if(isRecordUpdate==false) {
                            log.info(response.getHeader("Location").replace(request.getEndpoint()+"/",""));
                            status_message="inserted;"+response.getHeader("Location").replace(request.getEndpoint()+"/","");
                    }
                    else {
                            status_message="updated;"+source.target_sys_id;
                    }
            }
    }
    catch(e) {
            error=true;
            error_message=e.message;
    }
})(source, target, map, log, action==="update");


