(function scriptedWebServiceOperation(request, response) {
	
	var skipCount=0;
	var updateCount=0;
	var createCount=0;
	var strm;
	
	try {
		response.log_entries="";
		response.processed_target_list="";
		addToLog(response,request.target_table +": attachment migration ["+request.target_table+"]");
		var glideSysAttachment =new GlideSysAttachment();
		var targetIDSet=request.target_id_list.split(",");
		var sourceIDSet=request.source_id_list.split(",");
		if(targetIDSet.length!=sourceIDSet.length) {
			response.error_msg="Number of target entries ["+ targetIDSet.length +"] does not match number of source entries [" + sourceIDSet.length+"]";
			response.status="ERROR";
			return;
		}
		
		var sourceImageFields = request.source_image_list.split(",");
		var targetImageFields = request.target_image_list.split(",");
		var sourceImageFieldQueryString;
		var targetImageFieldQueryString;
		var imageFieldMap={};
		if(sourceImageFields.length!=targetImageFields.length) {
			response.error_msg="Number of target image fields ["+ targetImageFields.length +"] does not match number of source image fields [" + sourceImageFields.length+"]";
			response.status="ERROR";
			return;
		}
		var sourceImageFieldQueryString="";
		var targetImageFieldQueryString="";
		for(var j=0;j<sourceImageFields.length;j++) {
			if(j>0) {
				sourceImageFieldQueryString+="^OR";
				targetImageFieldQueryString+="^OR";
			}
			sourceImageFieldQueryString+="file_name="+sourceImageFields[j];
			targetImageFieldQueryString+="file_name="+targetImageFields[j];
			imageFieldMap[sourceImageFields[j]]=targetImageFields[j];
		}
		for(var i=0;i<targetIDSet.length;i++) {
			
			addToLog(response,"Processing attachments for source entry ["+ sourceIDSet[i]+"]");
                        //get the targetRecord
			var grTarget=new GlideRecord(request.target_table);
			if(!grTarget.get("sys_id", targetIDSet[i])) {
				response.error_msg="Target Entry " + targetIDSet[i]+ " not found";
				response.status="ERROR";
				return;
			}
			if(request.migrate_attachments.equals("TRUE")) {
				//get existing target attachments
				var grTargetAttachment=new GlideRecord("sys_attachment");
				grTargetAttachment.addEncodedQuery("table_name="+request.target_table+"^table_sys_id="+targetIDSet[i]);
				grTargetAttachment.query();
				var tgtAttachments={};
				while(grTargetAttachment.next()) {
					var attachmentRecord={};
					attachmentRecord["file_name"]=grTargetAttachment.getValue("file_name");
					attachmentRecord["size_bytes"]=grTargetAttachment.getValue("size_bytes");
					attachmentRecord["content_type"]=grTargetAttachment.getValue("content_type");
					attachmentRecord["sys_id"]=grTargetAttachment.getValue("sys_id");
					tgtAttachments[grTargetAttachment.getValue("file_name")]=attachmentRecord;
					grTargetAttachment.getValue("size_bytes");
				}
				//get the source attachments
				var grSourceAttachment=new GlideRecord("sys_attachment");
				grSourceAttachment.addEncodedQuery("table_name="+request.source_table+"^table_sys_id="+sourceIDSet[i]);
				grSourceAttachment.query();
				//check for new or changed attachments
				while(grSourceAttachment.next()) {
					var attachRecord=tgtAttachments[grSourceAttachment.getValue("file_name")];
					if(typeof attachRecord!="undefined" ){
						if(attachRecord["size_bytes"].equals(grSourceAttachment.getValue("size_bytes"))) {
						   //skip if size is the same on source and target
							skipCount++;
							addToLog(response,"Skip Duplicate Attachment: " + attachRecord["file_name"]);
						}
						else {
							//update
							//add new attachment
							strm=glideSysAttachment.getContentStream(grSourceAttachment.getValue("sys_id"));
							glideSysAttachment.writeContentStream(grTarget,grSourceAttachment.getValue("file_name"),grSourceAttachment.getValue("content_type"),strm);
							addToLog(response,"Add Updated Attachment :" + grSourceAttachment.getValue("file_name"));
							//delete original
							glideSysAttachment.deleteAttachment(attachRecord["sys_id"]);
							addToLog(response,"Delete Original Attachment :" + attachRecord["file_name"]);
							updateCount++;
						}
					}
					else {
						//create new record
						{
							strm=glideSysAttachment.getContentStream(grSourceAttachment.getValue("sys_id"));
							glideSysAttachment.writeContentStream(grTarget,grSourceAttachment.getValue("file_name"),grSourceAttachment.getValue("content_type"),strm);
							addToLog(response,"Create Attachment :" + grSourceAttachment.getValue("file_name"));
							createCount++;
						}
					}
				}
				//attachment migration complete
			}

			//next, handle the images if there are any
			//extract the set of image fields to migrate
			if(!sourceImageFieldQueryString.equals("")) {
				
				//get the source images
				var grSourceImage=new GlideRecord("sys_attachment");
				grSourceImage.addEncodedQuery("table_name=ZZ_YY"+request.source_table+"^table_sys_id="+sourceIDSet[i]);
				grSourceImage.addEncodedQuery(sourceImageFieldQueryString);
				grSourceImage.query();
				//get existing target images
				var grTargetImage=new GlideRecord("sys_attachment");
				grTargetImage.addEncodedQuery("table_name=ZZ_YY"+request.target_table+"^ORtable_name="+request.target_table);
				grTargetImage.addEncodedQuery("table_sys_id="+targetIDSet[i]);
				grTargetImage.addEncodedQuery(targetImageFieldQueryString);
				grTargetImage.query();
				var tgtImages={};
				while(grTargetImage.next()) {
					var imageRecord={};
					imageRecord["source_file_name"]=grTargetImage.getValue("file_name");
					imageRecord["target_file_name"]=imageFieldMap[grTargetImage.getValue("file_name")];
					imageRecord["size_bytes"]=grTargetImage.getValue("size_bytes");
					imageRecord["content_type"]=grTargetImage.getValue("content_type");
					imageRecord["sys_id"]=grTargetImage.getValue("sys_id");
					tgtImages[grTargetImage.getValue("file_name")]=imageRecord;
					grTargetImage.getValue("size_bytes");
				}
                                //check for new or changed images
				while(grSourceImage.next()) {
					var imgRecord=tgtImages[imageFieldMap[grSourceImage.getValue("file_name")]];
					if(typeof imgRecord!="undefined" ){
						if(imgRecord["size_bytes"].equals(grSourceImage.getValue("size_bytes"))) {
                                                    //skip if size is the same
                                                    skipCount++;
                                                    addToLog(response,"Skip Duplicate Image: " + imgRecord["target_file_name"]);
						}
						else {

                                                    //add new image as attachment
                                                    strm=glideSysAttachment.getContentStream(grSourceImage.getValue("sys_id"));
                                                    glideSysAttachment.writeContentStream(grTarget,imgRecord["target_file_name"],imgRecord["content_type"],strm);
                                                    addToLog(response,"Add Updated Image :" + imgRecord["target_file_name"]);
                                                    //delete original
                                                    glideSysAttachment.deleteAttachment(imgRecord["sys_id"]);
                                                    addToLog(response,"Delete Original Image :" +imgRecord["target_file_name"]);
                                                    updateCount++;
						}
					}
					else {
                                            //create new record
                                            strm=glideSysAttachment.getContentStream(grSourceImage.getValue("sys_id"));
                                            glideSysAttachment.writeContentStream(grTarget,imageFieldMap[grSourceImage.getValue("file_name")],grSourceImage.getValue("content_type"),strm);
                                            addToLog(response,"Create Image :" + imageFieldMap[grSourceImage.getValue("file_name")]);
                                            createCount++;
					}
				}
				//addToLog(response,"Image Migration Complete.");
				if(!response.processed_target_list.equals(""))response.processed_target_list+=",";
				response.processed_target_list+=targetIDSet[i];
			}
		}
		response.status="COMPLETE";
	}
	catch(e) {
            response.status="ERROR";
            if(e!=null) {
                addToLog(response,e);
                response.error_msg=e;
            }
	}
	response.update_count=updateCount.toFixed();
	response.create_count=createCount.toFixed();
	response.skip_count=skipCount.toFixed();
	addToLog(response,"Created :" + createCount.toFixed()+" Updated :" +updateCount.toFixed()+" Skipped :"+ skipCount.toFixed());
	
	
})(request, response);

function addToLog(response,msg) {
	response.log_entries+=msg+"\n";
}
