/* 
 * Copyright (c) Service Management Integrations Limited, 2014 - 2017
 * All Rights Reserved.
 * NOTICE: All information contained herein is and remains the property of Service Management  Integrations Limited.  The intellectual and technical concepts contained herein are proprietary to Service Management Integrations Limited and are protected by copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Service Management Integrations Limited.
 */
(function transformRow(source, target, map, log, isUpdate) {
	ignore=true;
	var item = new sn_sc.CatItem();
	var mappings={};
	try {
		mappings.active=source.active;
		mappings.availability=source.availability;
		mappings.billable=source.billable;
		mappings.can_cancel=source.can_cancel;
		mappings.category=source.category;
		mappings.cost=source.cost;
		mappings.custom_cart=source.custom_cart;
		mappings.delivery_plan=source.delivery_plan;
		mappings.delivery_plan_script=source.delivery_plan_script;
		mappings.delivery_time=source.delivery_time;
		mappings.description=source.description;
		mappings.entitlement_script=source.entitlement_script;
		mappings.group=source.group;
		mappings.icon=source.icon;
		mappings.ignore_price=source.ignore_price;
		mappings.image=source.image;
		mappings.list_price=source.list_price;
		mappings.location=source.location;
		mappings.meta=source.meta;
		mappings.mobile_hide_price=source.mobile_hide_price;
		mappings.moble_picture=source.moble_picture;
		mappings.mobile_picture_type=source.mobile_picture_type;
		mappings.model=source.model;
		mappings.name=source.name;
		mappings.no_cart=source.no_cart;
		mappings.no_order=source.no_order;
		mappings.no_order_now=source.no_order_now;
		mappings.no_proceed_checkout=source.no_proceed_checkout;
		mappings.no_quantity=source.no_quantity;
		mappings.no_search=source.no_search;
		mappings.omit_price=source.omit_price;
		mappings.order=source.order;
		mappings.ordered_item_link=source.ordered_item_link;
		mappings.picture=source.picture;
		mappings.preview=source.preview;
		mappings.price=source.price;
		mappings.recurring_frequency=source.recurring_frequency;
		mappings.recurring_price=source.recurring_price;
		mappings.redirect_url=source.redirect_url;
		mappings.roles=source.roles;
		mappings.sc_catalogs=source.sc_catalogs;
		mappings.sc_ic_item_staging=source.sc_ic_item_staging;
		mappings.sc_ic_version=source.sc_ic_version;
		mappings.script=source.script;
		mappings.short_description=source.short_description;
		mappings.show_variable_help_on_load=source.show_variable_help_on_load;
		mappings.start_closed=source.start_closed;
		mappings.sys_class_name=source.target_class_name;
		mappings.sys_created_by=source.target_created_by;
		mappings.sys_created_on=source.target_created_on;
		mappings.sys_customer_update=source.sys_customer_update;
		mappings.sys_mod_count=source.target_mod_count;
		mappings.sys_name=source.sys_name;
		mappings.sys_package=source.sys_package;
		mappings.sys_policy=source.sys_policy;
		mappings.sys_replace_on_upgrade=source.sys_replace_on_upgrade;
		if(!source.target_scope.equals("")) {
			mappings.sys_scope=getTargetScope(source.target_scope);
			if(mappings.sys_scope==null) {
				error=true;
				error_message="Invalid Application: "+ source.target_scope;
				log.info("error: sc_cat_item_producer entry");
				return;
			}
		}
		mappings.table_name=source.table_name;
		mappings.template=source.template;
		mappings.type=source.type;
		mappings.use_sc_layout=source.use_sc_layout;
		mappings.vendor=source.vendor;
		mappings.view=source.view;
		mappings.visible_bundle=source.visible_bundle;
		mappings.visible_guide=source.visible_guide;
		mappings.visible_standalone=source.visible_standalone;
		mappings.workflow=source.workflow;

		item.setTableName('sc_cat_item_producer');
	
		if(source.target_sys_id.equals("-1")) {
			log.info("create");
			item.setAttributes(mappings);
			var sys_id=item.create(true);
			log.info("created new sc_cat_item_producer entry: "+ sys_id);
			source.sys_target_sys_id=sys_id;
			action="insert";
			status_message="inserted;"+sys_id;
			source.update();
			log.info("created new sc_cat_item_producer entry: "+ sys_id);
		}
		else {
			mappings.sys_id=source.target_sys_id;
			log.info("updating sc_cat_item_producer entry: "+ mappings.sys_id);
			item.read(mappings,true);
			log.info("update");
			item.update(mappings,true);
			log.info("updated");
			source.sys_target_sys_id=mappings.sys_id;
			action="update";
			status_message="updated;"+mappings.sys_id;
			source.setValue("sys_import_state","updated");
			source.update();
			log.info("updated sc_cat_item_producer entry: "+ mappings.sys_id);
		 }
	}
	catch(e) {
		log.info("error: sc_cat_item_producer entry");
		error=true;
		error_message=e.message();
		source.sys_import_state="error";
		source.update();
	}
	
	function getTargetScope(applicationName) {
		var grScope=new GlideRecord("sys_scope");
		grScope.addQuery("name",applicationName);
		grScope.query();
		if(!grScope.next()) {
			return null;
		}
		else {
			return grScope.getValue("sys_id");
		}
		
	}

})(source, target, map, log, action==="update");